Galaxy = class("Galaxy")

function Galaxy:initialize()
	self.content = {}
end

function Galaxy:add( system )
	global.sys = global.sys or system
	table.insert(self.content,system)
	
end

function Galaxy:generate( seed )

	if seed then
		math.randomseed(seed)
	end

	local center = System("Center",0,0)
	center:generate()
	self:add(center)
	local names = System.listOfNames
	while (#self.content<10) do
		local tmp = self.content[math.random(1,#self.content)]
		if #tmp.links < 4 then
			local name = table.remove(names,math.random(1,#names))
			local distance = math.random(20,40)
			local radii = math.random(0,math.pi*2)
			local x = tmp.x + distance*math.cos(radii)
			local y = tmp.y + distance*math.sin(radii)
			local sys = System(name,x,y)
			sys:generate()
			self:add(sys)
			tmp:addLink(sys)
			sys:addLink(tmp)
		end
	end

	global.sys = self.content[1]

	for k,v in pairs(self.content) do
		print(k,v.name)
		for q,j in pairs(v.links) do
			print("->",j.name)
		end
	end
end

function Galaxy:update( dt )
	for k,v in pairs(self.content) do
		v:update(dt)
	end
end

function Galaxy:travel( destination,player )
	if (Galaxy:move(global.sys,destination,player.ship)) then
		global.sys = destination
	end
end


function Galaxy:move( origin,destination,ship )
	for k,v in pairs(origin.content) do
		if v == ship then
			table.remove(origin.content,k)
			table.insert(destination.content,ship)
			return true
		end
	end
	return false
end