require("conf")

require("MiddleClass")

require("ship")

require("player")
require("ai")

require("camera")

require("astro")
require("solar")
require("planet")
require("sun")
require("jumpgate")
require("system")
require("galaxy")

require("warpgate")

global = {}

function love.load()

	if (false) then
		local modes = love.graphics.getModes()
		table.sort(modes, function(a, b) return a.width*a.height < b.width*b.height end)
		local tmp = table.remove(modes)
		while (not love.graphics.checkMode(tmp.width,tmp.height,true)) do
			tmp = table.remove(modes)
		end
		
		love.graphics.setMode(tmp.width,tmp.height,true,true,0)
	end

	gal = Galaxy()
	global.gal = gal
	


	gal:generate()

	ship = Ship(0,0,0)
	ship.color={r=0,g=255,b=255}
	global.sys:add(ship)
	global.camera = Camera(ship)
	global.player = Player(ship)


end

function love.graphics.white()
	love.graphics.setColor(255,255,255,255)
end

function love.update(dt)
	gal:update(dt)
	global.camera:update()
	global.player:update(dt)
end

function love.draw()


	global.camera:draw()
	global.sys:draw()
	global.player:draw()
	
end

function love.quit()

end

function love.focus(f)

end

function love.keypressed( key, unicode )
	global.player:keypressed(key,unicode)
	if key == "escape" then
        love.event.push('quit') -- Quit the game.
    end 
	if key == "r" then
		--love.load()
		global.sys:generate()
	end
	if key == "p" then
		global.camera:screenshot()
	end
end

function love.keyreleased( key, unicode )

end

function love.mousepressed( x, y, button )
	global.sys:mousepressed(x,y,button)
end

function love.mousereleased( x, y, button )

end
