Player = class("Player")

function Player:initialize( ship )
	self.ship = ship
	self.showmap = false
	self.jumpIndex = 0
	self.jumpTarget = nil
end

function Player:keypressed( key,unicode )
	if key == "m" then
		self.showmap = not self.showmap
	end
	if key == "tab" then
		self.jumpIndex = self.jumpIndex + 1
		self.jumpTarget = global.sys.links[self.jumpIndex]
		if self.jumpTarget == nil then
			self.jumpIndex = 0
		end
	end
	if key == "j" then
		if self.jumpTarget then
			global.gal:travel(self.jumpTarget,self)
			self.jumpIndex = 0
			self.jumpTarget = nil
		end
	end
end

function Player:draw( )
	love.graphics.print("Index = "..self.jumpIndex,50,50)
	if self.showmap then
		for k,v in pairs(global.gal.content) do
			if v.discovered then
				local x = v.x*3+love.graphics.getWidth()/2
				local y = v.y*3+love.graphics.getHeight()/2
				if v == global.sys then
					love.graphics.setColor(255,255,255)
				else
					love.graphics.setColor(175,175,175)
				end
				love.graphics.circle("line",x,y,10)
				love.graphics.print(v.name,x,y)
				for q,j in pairs(v.links) do

					if v == global.sys or v == self.jumpTarget then
						if j == self.jumpTarget or j == global.sys then
							love.graphics.setColor(255,0,0)
						end
					end

					local x2 = j.x*3+love.graphics.getWidth()/2
					local y2 = j.y*3+love.graphics.getHeight()/2
					
					love.graphics.line(x,y,x2,y2)
					love.graphics.white()
				end
			end
		end
	end
end

function Player:update( dt )
	local thrust =0
	local turn = 0
	if love.keyboard.isDown("a") then
		turn = 1
	elseif love.keyboard.isDown("d") then
		turn = -1
	end
	if love.keyboard.isDown("w") then
		thrust=1
	elseif love.keyboard.isDown("s") then
		thrust=-1
	end
	self.ship:control(thrust,turn)

	
end