Ship = class("Ship")

function Ship:initialize( x,y,dir )
	self.x = x or 0
	self.y = y or 0
	self.velX = 0
	self.velY = 0
	self.dir = dir or 0
	self.signature = 3
	self.speedLimit = 500
end

function Ship:control(thrust,turn)
	if turn then
		if turn>0 then
			self.dir = self.dir + 0.01
		elseif turn<0 then
			self.dir = self.dir - 0.01
		end
	end
	if thrust then
		if thrust>0 then
			self.velX = self.velX + math.cos(self.dir)
			self.velY = self.velY + math.sin(self.dir)
		elseif thrust<0 then
			self.velX = self.velX - math.cos(self.dir)
			self.velY = self.velY - math.sin(self.dir)
		end
	end
end

function Ship:update( dt )

	

	if self.velX > self.speedLimit then
		self.velX = self.speedLimit
	elseif self.velX < -self.speedLimit then
		self.velX = -self.speedLimit
	end

	if self.velY > self.speedLimit then
		self.velY = self.speedLimit
	elseif self.velY < -self.speedLimit then
		self.velY = -self.speedLimit
	end


	self.x = self.x + self.velX*dt
	self.y = self.y + self.velY*dt

	self:control()
end

function Ship:draw( )
	if self.color then
		love.graphics.setColor(self.color.r,self.color.g,self.color.b,self.color.a or 255)
	else
		love.graphics.setColor(255,255,255,255)
	end
	local dx,dy,r = global.camera:Displace(self.x,self.y,10)
	local ex,ey = global.camera:Displace(self.x+math.cos(self.dir)*10,self.y+math.sin(self.dir)*10)
	love.graphics.circle("line",dx,dy,r, 40)
	love.graphics.line(dx,dy,ex,ey)

	local x = love.graphics.getWidth()/2
	local y = love.graphics.getHeight()/2
	love.graphics.line(x,y,x+math.cos(self.dir)*100,y-math.sin(self.dir)*100)

	love.graphics.white()
	--love.graphics.print("x:"..self.x.." y:"..self.y,dx,dy+30)
end
